import { max } from 'lodash';
<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component } from "vue-property-decorator";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { maxBy } from "lodash";
import { ISellerStoreItemShipping, IShipping } from "~/interfaces/store";

@Component({})
export default class SettingSellerShipping extends Vue {
  dialogShipping = false;
  loading = false;
  loadingTable = false;

  listUnit = [
    {
      name: "Quantity",
      value: "quantity",
    },
    {
      name: "Price",
      value: "price",
    },
  ];

  listShipping: any = [];
  listShippingView = [];
  shippingName = "";

  get storeId() {
    return this.$store.state?.sellerStore?.storeId || "";
  }

  mounted() {
    this.onGetDetail();
  }

  async onGetDetail() {
    try {
      if (!this.storeId) return;
      this.loadingTable = false;
      const response = await this.$api.store.detailStoreShipping(this.storeId);
      if (response?.data) {
        this.listShipping = response.data.listPrice.map(
          (item: ISellerStoreItemShipping) => ({
            unit: item.total ? "price" : "quantity",
            price: item.price,
            base: item.quantity || item.total,
          })
        );
        this.listShippingView = response.data?.listPrice || [];
        this.shippingName = response.data.name;
      }
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  openDialogShippng() {
    this.dialogShipping = true;
  }

  async onSave() {
    try {
      if (!this.storeId) return;
      this.loading = true;
      const body = {
        name: this.shippingName,
        listPrice: this.listShipping.map((item: any) => ({
          price: item.price,
          quantity: item.unit === "quantity" ? item.base : undefined,
          total: item.unit === "price" ? item.base : undefined,
        })),
      };
      await this.$api.store.updateStoreShipping(this.storeId, body);
      this.$pushNotification.success("Update store shipping successfully");
      this.onGetDetail();
      this.dialogShipping = false;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onAddRule() {
    const findLargestNumber = maxBy(this.listShipping, "base") || { base: 0 };
    this.listShipping.push({
      unit: "quantity",
      //@ts-ignore
      base: parseInt(findLargestNumber.base) + 1,
      price: 0,
    });
  }

  onRemove(i: number) {
    this.listShipping.splice(i, 1);
  }
}
</script>
<style lang="css">
.input-large-number .v-text-field__prefix {
  font-size: 12px !important;
}
</style>
